#pragma once

#include <ChimeraTK/ApplicationCore/ApplicationCore.h>
#include <ChimeraTK/ApplicationCore/ConfigReader.h>

// TODO Note to optionally use to trigger
#include <ChimeraTK/ApplicationCore/PeriodicTrigger.h>

#include "TecModule.h"


namespace ctk = ChimeraTK;

/**
 * tec_server Application
 *
 * All modules are simply connected to the ControlSystem.
 */
struct Server : public ctk::Application {
  Server(const std::string& name = "tec_server") : ctk::Application(name) {}
  ~Server() override { shutdown(); }

  ctk::ConfigReader config{this, "Configuration", getName() + "-config.xml", ctk::HierarchyModifier::hideThis};

  ctk::ControlSystemModule cs;
  ctk::DeviceModule dev{this, "Device"};
  ctk::PeriodicTrigger periodicRead{this, "PeriodicRead", "Trigger for periodic readout"};

  TecModule tecModule{this, "TecModule", "Read-write access to TEC parameters"};

  void defineConnections() override;
};
